#!/usr/bin/awk
#### եHTTPեץ mkup.awk V2.20 
#### Copyright 1998,1999,2000 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### ƥȺѥåȤFreeBSDΤߡ
#### 
#### History: 
#### 2000/11/07 V2.20 ѥ᡼ִб
####                  ξǼ³Τʤ顼åɽХ
#### 2000/09/20 V2.11 sjisƥȤǤʤեबɽʤХ
#### 2000/03/12 V2.02 chmod 666chmod o+wѹ
#### 2000/01/12 V2.01 GETDIRб
#### 1999/09/30 V2.00 ˥塼롣
#### 1999/09/26 V1.15 ưΥ顼Фʤ褦
#### 1998/12/16 V1.03 prev/today/nextб
#### 1998/12/15 V1.02 ǽεưǤΤȤlastuploadեդǵư褦ˤ
#### 1998/12/14 V1.01 ƥȥ⡼ɡʹ˷ɽˤɲá
####                  եιб 
#### 1998/12/13 V1.00  

BEGIN {
	if ( ARGC >= 6 ) {
		pass = ARGV[5];
	}
	if ( ARGC >= 5 ) {
		command = ARGV[4];
	}
	if ( ARGC >= 4 ) {
		year = ARGV[1];
		month = ARGV[2];
		date = ARGV[3];
		if ( (month==99) && (date==99) ) {
			diary = sprintf( KEEPDIR SLASH "%02d.html", year );
		} else {
			if ( (year==0) && (month==0) && (date==0) ) {
				lastupload = KEEPDIR SLASH LASTUPLOADNAME;
				while ( (getline < lastupload) > 0 ) {
					year = $1;
					month = $2;
					date = $3;
				}
				if ( year == 0 ) {
					split( strftime( "%Y %m %d", systime() ), today );
					year = today[1];
					month = today[2];
					date = today[3];
					print year, month, date >lastupload;
					close( lastupload );
					cmd = sprintf( CHMODCMD " %s", lastupload );
					system( cmd );
				}
				if ( year >= 1980 ) {
					system( AWKCMD " -f config.awk -f mkd.awk " year " " month " " date " test" );
				}
			}
			if ( command == "prev" ) {
				YMD2DAYS( year, month, date );
				DAYS2YMD( TOTALDAYS-1 );
				year = YEAR;
				month = MONTH;
				date = DATE;
			}
			if ( command == "next" ) {
				YMD2DAYS( year, month, date );
				DAYS2YMD( TOTALDAYS+1 );
				year = YEAR;
				month = MONTH;
				date = DATE;
			}
			diary = sprintf( GETDIR SLASH "%04d" SLASH "%02d%02d.html", year, month, date );
		}
	}
	mkup = "mkup.html";

	while ( (getline line<mkup) > 0 ) {
		if ( match( line, "/TEXTAREA" ) ) {
			if ( diary != "" ) {
				if ( (getline line2<diary) > 0 ) {
					close( diary );
					cmd = NKFCMD " -s " diary; # sjis
					while ( ((cmd) | getline line2) > 0 ) {
						gsub( "&", "&amp;", line2 );
						print line2;
					}
				}
			}
		} else if ( match( line, "YEAR" ) ) {
			if ( year != "" ) {
				s = sprintf( "%04d", year );
				sub( "VALUE=\"\"", "VALUE=\""s"\"", line );
			}
		} else if ( match( line, "MONTH" ) ) {
			if ( month != "" ) {
				s = sprintf( "%02d", month );
				sub( "VALUE=\"\"", "VALUE=\""s"\"", line );
			}
		} else if ( match( line, "DATE" ) ) {
			if ( date != "" ) {
				s = sprintf( "%02d", date );
				sub( "VALUE=\"\"", "VALUE=\""s"\"", line );
			}
		} else if ( match( line, "PASS" ) ) {
			if ( pass != "" ) {
				sub( "VALUE=\"\"", "VALUE=\""pass"\"", line );
			}
		} else if ( match( line, "DIGESTDIARY" ) ) {
			sub( "DIGESTDIARY" , PUTDIR SLASH DIGESTNAME, line );
		} else if ( match( line, "/BODY" ) ) {
			cmd = NKFCMD " -s " TMPDIR SLASH "test.html"; # åץѤϾsjis
			system( cmd );
		}
		print line;
	}
	close( mkup );
}

########################################################################
###  
#
function Setup_DAYS( year )
{
	DAYS[1] = 31;
	DAYS[2] = 28;
	DAYS[3] = 31;
	DAYS[4] = 30;
	DAYS[5] = 31;
	DAYS[6] = 30;
	DAYS[7] = 31;
	DAYS[8] = 31;
	DAYS[9] = 30;
	DAYS[10] = 31;
	DAYS[11] = 30;
	DAYS[12] = 31;
	if ( (((year%4) == 0) && ((year%100) != 0)) || ((year%400) == 0) ) {
		DAYS[2] = 29;
	}
}

########################################################################
### ǯ 
#
function Setup_DAYS1( year )
{
	DAYS1 = 365;
	if ( (((year%4) == 0) && ((year%100) != 0)) || ((year%400) == 0) ) {
		DAYS1++;
	}
}

########################################################################
### ǯ1980/01/01ѻաפ 
#
function YMD2DAYS( year, month, date       ,days, i )
{
	if ( date < 1 ) {
		error_arg("date<1");
	}
	Setup_DAYS( year );
	days = DAYS[month];
	if ( date > days ) {
		error_arg("date>end " date ">" days);
	}

	TOTALDAYS = 0;
	for ( i=1980; i<year; i++ ) {
		Setup_DAYS1( i );
		TOTALDAYS += DAYS1;
	}
	for ( i=1; i<month; i++ ) {
		TOTALDAYS += DAYS[i];
	}
	TOTALDAYS += date-1;

	WDAY = (TOTALDAYS+2) % 7;  # SUN->SAT 
}

########################################################################
### 1980/01/01ѻաפǯ 
#
function DAYS2YMD( totaldays )
{
	WDAY = (TOTALDAYS+2) % 7;  # SUN->SAT 

	for ( YEAR=1980; YEAR<2100; YEAR++ ) {
		Setup_DAYS1( YEAR );
		if ( DAYS1 > totaldays ) {
			break;
		}
		totaldays -= DAYS1;
	}

	Setup_DAYS( YEAR );
	for ( MONTH=1; MONTH<=12; MONTH++ ) {
		if ( DAYS[MONTH] > totaldays ) {
			break;
		}
		totaldays -= DAYS[MONTH];
	}

	DATE = totaldays+1;
}

function error_arg(s)
{
	print "error_arg " s;
	exit;
}

# [EOF]
